<?php

namespace Ig\IgNewsletter\ViewHelpers;


use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer;
use TYPO3Fluid\Fluid\Core\Compiler\TemplateCompiler;
use TYPO3Fluid\Fluid\Core\Parser\SyntaxTree\ViewHelperNode;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;

class GridViewHelper extends AbstractViewHelper
{
    /**
     * @var boolean
     */
    protected $escapeOutput = false;
    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        $this->registerArgument('cols', 'mixed', 'Number of cols', false, 1);
        $this->registerArgument('width', 'string', 'width in Pixel', false);
        $this->registerArgument('layout', 'mixed', 'Layout/Configuration Name', false);
        $this->registerArgument('frameClass', 'mixed', 'Class/Configuration Name', false);
        //$this->registerArgument('config', 'mixed', 'Configuration Name', false, '');
        $this->registerArgument('class', 'mixed', 'Class/Configuration Name', false, '');
        $this->registerArgument('responsive', 'boolean', 'responsive otherwise fix', false, true);
    }
    
    /**
     * @param array $arguments
     * @param \Closure $renderChildrenClosure
     * @param RenderingContextInterface $renderingContext
     * @return \Ig\IgResponsiveImages\Domain\Model\Page
     * @throws \TYPO3\CMS\Fluid\Core\ViewHelper\Exception
     */
    static public function renderStatic(array $arguments, \Closure $renderChildrenClosure, RenderingContextInterface $renderingContext) {
        $setupUtility=GeneralUtility::makeInstance(\Ig\IgNewsletter\Utility\SetupUtility::class);
        $current=$setupUtility->getCurrent();
        if( isset($arguments['width'])) {
            $setupUtility->setWidth(intval($arguments['width']));
        }
        $debugOutput='';
        $setupUtility->setTotalNumberOfCols( $arguments['cols'] );
        if( isset($arguments['layout'])) {
            //echo('layout='.$arguments['layout'].'<br />');
            $debugOutput.=$setupUtility->setLayoutConfig($arguments['layout'], 'outerBox');
        }
        if( isset($arguments['frameClass'])) {
            $setupUtility->setFrameClass($arguments['frameClass']);
        }
        $debugOutput.=$setupUtility->startTable();

        $contentArray=$setupUtility->getOuterBox( $arguments['responsive'], $arguments['class'] );
        $content= $contentArray['begin'] . $renderChildrenClosure() . $contentArray['end'];
        $setupUtility->setCurrent( $current );
        return $debugOutput . $content;
    }

}