<?php

namespace Ig\IgNewsletter\ViewHelpers;


use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer;
//suse WebentwicklerAt\Emogrifier\Utility\EmogrifierUtility;

class InlineCssViewHelper extends AbstractViewHelper
{
    /**
     * @var boolean
     */
    protected $escapeOutput = false;

    /**
     * Initialize arguments.
     *
     * @throws \TYPO3Fluid\Fluid\Core\ViewHelper\Exception
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        $this->registerArgument('src', 'string', 'CSS filename', false);
        $this->registerArgument('style', 'string', 'CSS as a string.', false);
    }

    /**
     * @return string
     */
    public function render()
    {
        $content = $this->renderChildren();
	$css='';
	if( isset($this->arguments['style']) ) {
	  $css .= $this->arguments['style'];
	}
	if( isset($this->arguments['src']) ) {
	  $src=GeneralUtility::getFileAbsFileName($this->arguments['src']);
	  $css .= file_get_contents($src);
	}

	if($css=='') {
	  return $content;
	}
        $extractContent = true;
	$emogrifier = new \Pelago\Emogrifier();
	$emogrifier->setHtml($content);
	$emogrifier->setCss($css);
	return $emogrifier->emogrifyBodyContent();
	
        //return EmogrifierUtility::emogrify($content, $css, $extractContent);
    }

}
